package be.cylab.java.wowa.training;

//import info.debatty.java.aggregation.WOWA;

import java.util.Arrays;
import java.util.List;

public class SolutionDistance implements Comparable<SolutionDistance> {

    public double[] weights_w;
    public double[] weights_p;
    private double distance = Double.POSITIVE_INFINITY;


    public SolutionDistance(int weights_number) {
        this.weights_w = new double[weights_number];
        this.weights_p = new double[weights_number];
    }

    /**
     *
     * @return
     */
    @Override
    public String toString() {
        return "SolutionDistance{" +
                "weights_w=" + Arrays.toString(weights_w)
                + ", weights_p=" + Arrays.toString(weights_p)
                + ", distance=" + distance
                + '}';
    }

    /**
     *
     * @param data
     * @param expected
     */
    public void computeScoreTo(List<double[]> data, double[] expected) {

        this.distance = Math.random();

    }

    /**
     *
     * @param probability
     */
    public void randomlyMutateWithProbability(final double probability) {
        double tos = Math.random();
        if (tos > probability) {
            // do nothing
            return;
        }

        //new weight value and position
        double newWeightValue = Math.random();
        int randomIndex = Utils.randomInteger(0, this.weights_p.length - 1);
        //Select w or p weights
        int weightSelection = Utils.randomInteger(0, 1);
        if (weightSelection == 0) {
            this.weights_w[randomIndex] = newWeightValue;
        } else {
            this.weights_p[randomIndex] = newWeightValue;
        }
        this.normalize();

    }

    /**
     *
     * @param solution
     * @return
     */
    @Override
    public int compareTo(final SolutionDistance solution) {
        return this.getDistance() > solution.getDistance() ? -1 : this.getDistance() < solution.getDistance() ? 1 : 0;
    }

    /**
     *
     */
    public void normalize() {
        this.weights_w = Utils.normalizeWeights(this.weights_w);
        this.weights_p = Utils.normalizeWeights(this.weights_p);
    }

    /**
     *
     * @return
     */
    public double getDistance() {
        return distance;
    }

}
